// -*- C++ -*-

#ifndef _ERROR_H_
#define _ERROR_H_

#include <assert.h>
#include <errno.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

// These methods are inline because of a g++ / libg++ problem. I'll
// install next revision of libg++ one day (current is 2.5.3).

inline ostream &stop(ostream &foo)
{
      assert(!"Stopping...");
      return foo;
}

inline ostream &niy(ostream &s)
{
      s << " not implemented yet" << endl;
      assert(!"implemented");
      return s;
}

class error {
      
    public:
      inline static ostream &last(ostream &);

};

inline static const char *identifier() { return "<unidentified>"; }

#define ERRLOCATION __FILE__ << ':' << __LINE__
#define SYSERR      ERRLOCATION << ": " << error::last << stop;

#define dubious_const_cast const_cast

// ============================================================================= 

ostream &error::last(ostream &s)
{
      s << strerror(errno);
      return s;
}

#endif // _ERROR_H_
