// -*- C++ -*-
//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Thu Jan 30 11:20:28 1997
//

#ifndef _VIDEO_IMAGE_SOURCE_H_
#define _VIDEO_IMAGE_SOURCE_H_

#include "videoMemoryDrain.h"
#include "videoServer.h"
#include "videoSinglePath.h"
#include "videoVideoSource.h"

class videoBufferPool;
class videoIBuffer;
class videoTransferringPath;

class videoImageSource {

    public:
      videoImageSource(bool noModification = false, int source = VL_ANY);
      ~videoImageSource();
      inline void setZoom(unsigned numerator, unsigned denominator);
      inline void setPacking(int packing);
      inline void getSize(unsigned *width, unsigned *height) const;
      char *getNextImage();

    private:
      videoServer _server;
      videoVideoSource _source;
      videoMemoryDrain _drain;
      videoSinglePath _path;
      videoBufferPool *_pool;
      videoTransferringPath *_transfer;
      videoIBuffer *_buffer;
      bool _noModification;
};

#include "videoImageSource_inline.cc"

#endif // _VIDEO_IMAGE_SOURCE_H_

