#
# Written by Ch. Tronche (http:#www-ihm.lri.fr/~tronche/)
# Copyright by the author. This is unmaintained, no-warranty free software. 
# Please use freely. It is appreciated (but not mandatory) to acknowledge
# the author's contribution. Thank you.
# Started on Tue Oct  1 21:31:06 1996
#

all::

%.a: %.o
	$(AR) r $@ $?

%.ii: %.cc
	$(PREPROCESS.cc) $< -o $@ $(OUTPUT_OPTION)

%.s: %.cc
	$(GENAS.cc) $< $(OUTPUT_OPTION)
	
TLIB	= -L../../lib

%: %.o
	$(LINK.cc) $^ $(LOADLIBES) $(TLIB) $(LDLIBS) -o $@

%.cc:	%.l
	$(LEX++.l) $< > $@

%.cc: %.y
	$(YACC.y) $< -o $@
	mv $*.cc.h $*.h

%.h: %.y
	$(YACC.y) $< -o toto
	mv toto.h $@
	rm toto

snapshot:
	tar zcf snapshot-`date +%y%m%d-%H%M`.tar.gz *.cc *.h makefile

#%.o: %.cc
#	$(COMPILE.cc) -c $? $(OUTPUT_OPTION)

OUTPUT_OPTION	=

COMPILE.cc	= $(XCOMPILE.cc) -c
GENAS.cc	= $(XCOMPILE.cc) -S
LEX++.l		= $(LEX++) $(LFLAGS) -t
LINK.cc		= $(CXX) $(CXXFLAGS) -Wall $(LDFLAGS) $(TARGET_ARCH)
#LINK.cc		= $(CXX) $(CXXFLAGS) -Wall $(LDFLAGS) $(TARGET_ARCH) -Xlinker -quickstart_info
PREPROCESS.cc	= $(CXX) $(CXXFLAGS) -E $(TCPPFLAGS) $(TARGET_ARCH)
CXXWARN		= -Wall -Wpointer-arith
#CXXDEBUG        = -g
CXXFLAGS        = -g
XCOMPILE.cc	= $(CXX) $(CXXWARN) -fno-implicit-templates $(CXXARCH) $(CXXDEBUG) $(CXXFLAGS) $(TCPPFLAGS) $(TARGET_ARCH)

CC	= gcc
LEX++	= flex++
LFLAGS	= -s
YACC	= bison
YFLAGS	= -d

TCPPFLAGS	= $(CPPFLAGS) -I../../include

clean::
	rm -f $(OBJS)  $(GENERATED) *.[aos] *~ *.ii
