//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but by no means mandatory) to
// acknowledge the author's contribution. Thank you.
// Started on Mon Mar 10 15:12:17 1997
//

#include <assert.h>
#include <bstring.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>

#include "tcpAccepter.h"


tcpAccepter::tcpAccepter(unsigned short port, bool reuseAddr = true)
:_port(port)
{
      _sd = socket(PF_INET, SOCK_STREAM, 0);
      assert(_sd >= 0);
      int enable = 1;
      assert(!setsockopt(_sd, SOL_SOCKET, SO_REUSEADDR, &enable, sizeof(enable)));
      if (port) {
	    sockaddr_in addr;
	    addr.sin_family = AF_INET;
	    addr.sin_port = port;
	    addr.sin_addr.s_addr = INADDR_ANY;
	    bzero(addr.sin_zero, 8);
	    assert(!bind(_sd, &addr, sizeof(addr)));
      }
      assert(!listen(_sd, 5));
}

int tcpAccepter::accept()
{
      sockaddr_in addr;
      int addrlen = sizeof(addr);
      int res = ::accept(_sd, &addr, &addrlen);
      assert(res >= 0);
      return res;
}

int tcpAccepter::port() const
{
      if (!_port) {
	    sockaddr_in addr;
	    int addrlen = sizeof(addr);
	    assert(!getsockname(_sd, &addr, &addrlen));
	    const_cast<tcpAccepter *>(this) -> _port = addr.sin_port;
      }
      return _port;
}
