// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but by no means mandatory) to
// acknowledge the author's contribution. Thank you.
// Started on Mon Mar 10 15:36:23 1997

#include <net++/tcpAccepter.h>
#include <fstream.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <video++/videoImageSource.h>

#include "gifAddGraphicControlExtension.h"
#include "gifFrom8.h"
#include "gifUtils.h"
#include "oGifStream.h"

static const char header[] = // This is sent whatever the request's version is !
"HTTP/1.0 200 OK\n"
"Content-Type: image/gif\n"
"Server: Tronche's animated GIF server 0.90 (http://tronche.lri.fr:8000/internet/server/animated-gif/)\n"
"\n";

main()
{
      tcpAccepter accepter(8002);
      for(;;) {
	    int fd = accepter.accept();
	    int statptr;
	    if (!fork()) {
		  char buffer[1024];
		  read(fd, buffer, 1024);
		  if (buffer[0] == 'G' && buffer[1] == 'E' && buffer[2] == 'T'
		      && buffer[3] == ' ' && buffer[4] == '/' && buffer[5] >= '1'
		      && buffer[5] <= '8') {
			videoImageSource s(false, 0);
			s.setZoom(1, buffer[5] - '0');
			s.setPacking(VL_PACKING_RGB_332_P);
			unsigned width, height;
			s.getSize(&width, &height);

			ofstream stream(fd);
			stream << header;
			oGifStream gif(&stream, width, height, gifUtils::rgb332gifColorTable());

			unsigned length = width * height;
			for(;;) {
			      gif << gifAddGraphicControlExtension(0, gifAddGraphicControlExtension::doNotDispose) << gifFrom8(s.getNextImage(), length);
			      stream << flush;
			}
		  } else if (buffer[0] == 'H' && buffer[1] == 'E' && buffer[2] == 'A' && buffer[3] == 'D' && buffer[4] == ' ') {
			ofstream stream(fd);
			stream << header;
		  }
		  exit(0); // Actually, should die on a SIGPIPE
	    } else {
		  close(fd);
		  waitpid(-1, &statptr, WNOHANG);
		  waitpid(-1, &statptr, WNOHANG);
	    }
      }
}
