// -*- C++ -*-

#ifndef _GIF_COLOR_TABLE_H_
#define _GIF_COLOR_TABLE_H_

#include <assert.h>
#include <standardInclude.h>

class gifColorTable {

    public:
      gifColorTable(unsigned char packedSize, const unsigned char *table = NIL);
      ~gifColorTable();
      inline const unsigned char *operator[](unsigned index) const; // alias
      inline unsigned entryNumber() const;
      inline unsigned size() const;

    public:
      inline static unsigned entryNumber(unsigned char packedSize);
      inline static unsigned size(unsigned char packedSize);

    private:
      static const entrySize = 3;

    private:
      unsigned _entryNumber;
      unsigned _packedSize;
      const unsigned char *_table;
      bool _tableIsMine;

};

#include "gifColorTable_inline.cc"

#endif // _GIF_COLOR_TABLE_H_
