//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Mon Mar  3 12:21:48 1997
//

#include "gifFrom8.h"
#include "gifLZPatternTable.h"
#include "gifLZStreamPacker.h"
#include "oGifStream.h"

void gifFrom8::store(oGifStream &s)
{
      s.put(0x2c);
      s.storeUnsigned16(0);
      s.storeUnsigned16(0);
      s.storeUnsigned16(s.screenWidth());
      s.storeUnsigned16(s.screenHeight());
      s.put(0); // No flag
      s.put(8); // 8 bits per pixel
      {
	    ostream &ref = s;
	    gifLZStreamPacker pack(&ref);
	    const char *d = _data;
	    gifLZPatternTable t(&pack, *d++);
	    unsigned long length = _length - 1;
	    while(length--)
		  t.update(*d++);
	    // Destroying the gifLZPatternTable will complete the output
      }
      s.put(0); // End of the data sub-blocks
}

gifFrom8::gifFrom8(const char *data, unsigned long length)
:_data(data), _length(length)
{
      // void
}
