// -*- C++ -*-
//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Wed Mar  5 20:56:25 1997
//

#ifndef _GIF_L_Z_MEMORY_PACKER_H_
#define _GIF_L_Z_MEMORY_PACKER_H_

#include <standardInclude.h>

#include "gifLZPacker.h"

class gifLZMemoryPacker: public gifLZPacker {

    public:

      // Better give a buffer big enough. After destruction, lastBufferPosition points at the first free position in buffer
      // It is safe to pass the same variable as both buffer and lastBufferPosition

      inline gifLZMemoryPacker(char *buffer, char **lastBufferPosition); 
      inline ~gifLZMemoryPacker();

    private:
      inline void append(unsigned);

    private:
      char *_bufferPosition;
      unsigned _bufferSpaceLeft;
      char **const _lastBufferPosition;

};

#include "gifLZMemoryPacker_inline.cc"

#endif // _GIF_L_Z_MEMORY_PACKER_H_

