
gifLZMemoryPacker::gifLZMemoryPacker(char *buffer, char **lastBufferPosition)
:_bufferPosition(buffer + 1), _bufferSpaceLeft(254), _lastBufferPosition(lastBufferPosition)
{
      // void
}

gifLZMemoryPacker::~gifLZMemoryPacker()
{
      if (_left < 8) {
	    *_bufferPosition++ = _bitAccumulator;
	    _bufferSpaceLeft--;
      }

      int buffered = 254 - _bufferSpaceLeft;
      if (buffered)
	    _bufferPosition[-buffered - 1] = buffered;
      else
	    _bufferPosition--;               // We advanced the pointer past the last position in the last append

      *_lastBufferPosition = _bufferPosition;
}

inline void gifLZMemoryPacker::append(unsigned n)
{
      bool resetSize = n == 256;

      // bits is the number of bits to store

      for(int bits = _size; bits ;) {              // We've to store as many bits as the code size
	    _bitAccumulator |= n << 8 - _left;     // Store them
	    unsigned bitStored = MIN(_left, bits);
	    n >>= bitStored;
	    bits -= bitStored;
	    _left -= bitStored;
	    if (!_left) {

		  *_bufferPosition++ = _bitAccumulator;
		  _bufferSpaceLeft--;
		  if (!_bufferSpaceLeft) {
			_bufferPosition[-255] = 254;
			_bufferPosition++; // Leave a slot for the next data sub-block size
			_bufferSpaceLeft = 254;
		  }

		  _bitAccumulator = 0;
		  _left = 8;
	    }
      }

      if (resetSize) _size = 9;
}
