// -*- C++ -*-
//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Wed Mar  5 17:23:01 1997
//

#ifndef _GIF_L_Z_PATTERN_TABLE_H_
#define _GIF_L_Z_PATTERN_TABLE_H_

#include <assert.h>
#include <standardInclude.h>

#include "gifLZPacker.h"

class gifLZPatternTable {

    public:
      inline gifLZPatternTable(gifLZPacker *, unsigned initialValue);
      inline ~gifLZPatternTable();
      inline void update(unsigned char value);

    private:
      struct patternCell {
	    char _char;
	    unsigned short _used;
	    patternCell *_nextWithSameHashValue;
	    patternCell *_next[16];
      };
      static const tableSize = 4096;

    private:
      inline void addCell(unsigned char v, patternCell *lastPattern);
      inline void output(const patternCell *) const;
      inline void output(unsigned) const;

    private:
      gifLZPacker &_packer;
      patternCell _table[tableSize];
      patternCell *_last;
      patternCell *_current;
      patternCell *const _tableEnd;
      unsigned _codeSize;
      unsigned _maxCode;             // If table index grows bigger than _maxCode, we've to increase the code size

};

#include "gifLZPatternTable_inline.cc"

#endif // _GIF_L_Z_PATTERN_TABLE_H_

