//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Mon Mar  3 11:41:20 1997
//

#include <iostream.h>
#include <standardInclude.h>

#include "gifColorTable.h"
#include "gifLZMemoryPacker.h"
#include "gifLZPatternTable.h"
#include "gifUtils.h"


static gifColorTable *rgb332Table = NIL;

static const char val2[] = { 0, 85, 171, 255 };
static const char val3[] = { 0, 37, 73, 110, 146, 183, 219, 255 };

const gifColorTable *gifUtils::rgb332gifColorTable()
{
      if (!rgb332Table) {
	    unsigned char *table = new unsigned char[256 * 3];
	    unsigned char *p = table;
	    for(unsigned blue = 0; blue < 4; blue++)
		  for(unsigned green = 0; green < 8; green++)
			for(unsigned red = 0; red < 8; red++) {
			      *p++ = val3[red];
			      *p++ = val3[green];
			      *p++ = val2[blue];
			}
	    rgb332Table = new gifColorTable(7, table);
      }
      return rgb332Table;
}

static char *storeUnsigned16(char *buffer, unsigned n)
{
      *buffer++ = n & 0xff;
      *buffer++ = (n >> 8) & 0xff;
      return buffer;
}

char *gifUtils::memoryImageFrom8(const char *image, unsigned width, unsigned height, char *buffer)
{
      *buffer++ = 0x2c;
      *buffer++ = 0, *buffer++ = 0;   // Image at position 0, 0 in the screen
      *buffer++ = 0, *buffer++ = 0;
      buffer = storeUnsigned16(buffer, width);
      buffer = storeUnsigned16(buffer, height);
      *buffer++ = 0;   // No flag
      *buffer++ = 8;   // 8 bits per pixel
      {
	    gifLZMemoryPacker pack(buffer, &buffer);
	    gifLZPatternTable t(&pack, *buffer++);
	    for(unsigned l = width * height; l; l--)
		  t.update(*image++);
	    // Destroying the packer will update `buffer'
      }
      *buffer++ = 0;
      return buffer;
}
