// -*- C++ -*-
//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Mon Mar  3 10:49:35 1997
//

#ifndef _O_GIF_STREAM_H_
#define _O_GIF_STREAM_H_

#include <fstream.h>
#include <iostream.h>

#include "gifStreamable.h"

class gifColorTable;

class oGifStream {

    public:
      oGifStream(ostream *physical, unsigned screenWidth, unsigned screenHeight, const gifColorTable *globalColorTable,
		 unsigned backgroundColorIndex = 0, unsigned pixelAspectRatio = 0, unsigned colorResolution = 0x7, 
		 bool globalColorTableSorted = false);
      inline ~oGifStream();

      inline unsigned screenWidth() const;
      inline unsigned screenHeight() const;
      inline void storeUnsigned16(unsigned);
      inline void put(char);
      inline void write(const char *, unsigned length);

      inline oGifStream &operator<<(gifStreamable &);
      inline operator ostream &();

    protected:
      inline void sendTrailer(); // derived classes destructor may want to use this idempotent function

    private:
      unsigned _screenWidth, _screenHeight;
      ostream &_physical;

};

#include "oGifStream_inline.cc"

#endif // _O_GIF_STREAM_H_

