#include <error++/error.h>
#include <vl/dev_ev1.h>

#include "videoBlendedPath.h"
#include "videoDrain.h"
#include "videoError.h"
#include "videoSource.h"

videoBlendedPath::videoBlendedPath(videoSource *background, videoSource *foreground, videoDrain *d, int keyerMode, bool alphaIsBackground)
:videoPath(d), _blender(d -> server(), foreground, background, keyerMode, alphaIsBackground ? background : foreground)
{
      _path = vlCreatePath(_server, VL_ANY, *background, *d);
      if (_path < 0) cerr << "videoPath::videoPath: vlCreatePath: " << videoError << stop;
      vlAddNode(_server, _path, *foreground);
      vlAddNode(_server, _path, _blender);
      if (vlSetupPaths(_server, &_path, 1, VL_SHARE, VL_SHARE) < 0)
 	    cerr << "videoPath::videoPath: vlSetupPaths: " << videoError << stop;
      _transferSize = -1;
      _blender.pathSetUp(_path);
      d -> pathSetUp(_path);
}
