#include <error++/error.h>
#include <vl/dev_ev1.h>

#include "videoBlender.h"
#include "videoSource.h"

videoBlender::videoBlender(videoServer *s, videoSource *foreground, videoSource *background, int keyerMode, videoSource *keyerSource)
:videoNode(s, VL_INTERNAL, VL_BLENDER, VL_ANY)
{
      _foreground = foreground;
      _background = background;
      _keyerSource = keyerSource;
      _keyerMode = keyerMode;
}

void videoBlender::pathSetUp(VLPath path)
{
      setIntControl(path, VL_EV1_KEYER_MODE, _keyerMode);
      setIntControl(path, VL_BLEND_B_ALPHA, *_keyerSource);
      setIntControl(path, VL_BLEND_A, *_foreground);
      setIntControl(path, VL_BLEND_B, *_background);
}
