#include <vl/dev_ev1.h>

#include "videoChromaBlendedPath.h"

videoChromaBlendedPath::videoChromaBlendedPath(videoSource *s1, videoSource *s2, videoDrain *d)
:videoBlendedPath(s1, s2, d, VL_EV1_KEYERMODE_CHROMA)
{
      // void
}

int videoChromaBlendedPath::detail() const
{
      return _blender.getIntControl(_path, VL_EV1_KEYER_DETAIL);
}

void videoChromaBlendedPath::setDetail(int v)
{
      _blender.setIntControl(_path, VL_EV1_KEYER_DETAIL, v);
}

void videoChromaBlendedPath::setValue(int u, int v)
{
      _blender.setIntControl(_path, VL_EV1_KEYER_VALUE_CHROMA_U, u);
      _blender.setIntControl(_path, VL_EV1_KEYER_VALUE_CHROMA_V, v);
}

void videoChromaBlendedPath::setRange(int u, int v)
{
      _blender.setIntControl(_path, VL_EV1_KEYER_RANGE_CHROMA_U, u);
      _blender.setIntControl(_path, VL_EV1_KEYER_RANGE_CHROMA_V, v);
}

void videoChromaBlendedPath::getValue(int *u, int *v)
{
      *u = _blender.getIntControl(_path, VL_EV1_KEYER_VALUE_CHROMA_U);
      *v = _blender.getIntControl(_path, VL_EV1_KEYER_VALUE_CHROMA_V);
}

void videoChromaBlendedPath::getRange(int *u, int *v)
{
      *u = _blender.getIntControl(_path, VL_EV1_KEYER_RANGE_CHROMA_U);
      *v = _blender.getIntControl(_path, VL_EV1_KEYER_RANGE_CHROMA_V);
}
