//
// Written by Ch. Tronche (http://tronche.lri.fr:8000/)
// Copyright by the author. This is unmaintained, no-warranty free software. 
// Please use freely. It is appreciated (but not mandatory) to acknowledge
// the author's contribution. Thank you.
// Started on Thu Jan 30 11:20:29 1997
//

#include "videoImageSource.h"
#include "videoTransferringPath.h"


videoImageSource::videoImageSource(bool noModification, int source)
:_source(&_server, source), _drain(&_server), _path(&_source, &_drain), _noModification(noModification)
{
      _pool = NIL;
      _transfer = NIL;
      _buffer = NIL;
}

char *videoImageSource::getNextImage()
{
      if (!_pool) {
	    _pool = new videoBufferPool(&_path, &_drain, 2, _noModification);
	    _transfer = new videoTransferringPath(&_path);
      }
      delete _buffer;
      _buffer = new videoIBuffer(_pool);
      return static_cast<char *>(_buffer -> activeRegion());
}

videoImageSource::~videoImageSource()
{
      delete _pool;
      delete _transfer;
      delete _buffer;
}
