/*-*- C++ -*-*/

#ifndef _VIDEO_NODE_H_
#define _VIDEO_NODE_H_

#include <vl/vl.h>

class videoPath;
class videoServer;

class videoNode {

    public:
      videoServer *server();
      void getSize(const videoPath &, unsigned *width, unsigned *height) const;
      void setSize(const videoPath &, int width, int height);
      inline operator VLNode() const;

      // Suppose to be used only by path (not the user)

      int getIntControl(VLPath, VLControlType) const;
      void getFractControl(VLPath, VLControlType, int *numerator, int *denominator);
      void setIntControl(VLPath, VLControlType, int value) const;
      void setFractControl(VLPath, VLControlType, int numerator, int denominator);

    protected:
      videoNode(videoServer *, int type, int kind, int number);

    protected:
      videoServer *_server;
      VLServer    _serverHandle;

//  friend class videoPath;

      VLNode _node;

    protected:

      void getXYControl(VLPath, VLControlType, int *x, int *y) const;
      void setXYControl(VLPath, VLControlType, int x, int y) const;

};

#include "videoNode_inline.cc"

#endif // _VIDEO_NODE_H_
