#include <iostream.h>

#include "videoPath.h"
#include "videoScreenDrain.h"
#include "videoServer.h"

videoScreenDrain::videoScreenDrain(videoServer *s, Display *d, Window w)
:videoDrain(s, VL_SCREEN)
{
      _display = d;
      _window = w;
}

void videoScreenDrain::setOrigin(videoPath &path, unsigned x, unsigned y)
{
      setXYControl(path, VL_ORIGIN, x, y);
}

void videoScreenDrain::pathSetUp(VLPath path)
{
      VLControlValue val;
      val.intVal = _window;
      vlSetControl(_serverHandle, path, _node, VL_WINDOW, &val);

      Window foo;
      int x, y;
      XTranslateCoordinates(_display, _window, RootWindow(_display, DefaultScreen(_display)), 0, 0,&x, &y, &foo); // ???
			  
      val.xyVal.x = 0;
      val.xyVal.y = 0;
      vlSetControl(_serverHandle, path, _node, VL_ORIGIN, &val); 
}

void videoScreenDrain::setSize(videoPath &path, unsigned width, unsigned height)
{
      setXYControl(path, VL_SIZE, width, height);
}

void videoScreenDrain::setOriginAndSize(videoPath &path, const XConfigureEvent &e)
{
      Window foo;
      int x, y;
      XTranslateCoordinates(_display, _window, DefaultRootWindow(_display), 0, 0, &x, &y, &foo);
      setOrigin(path, x, y);
      setSize(path, e.width, e.height);
}

void videoScreenDrain::setWindow(Window w)
{
      _window = w;
}
