#include <error++/error.h>

#include "videoDrain.h"
#include "videoError.h"
#include "videoSinglePath.h"
#include "videoSource.h"

void videoSinglePath::setup(videoSource *s, videoDrain *const d[])
{
      _path = vlCreatePath(_server, VL_ANY, *s, **d);
      if (_path < 0) cerr << "videoPath::videoPath: vlCreatePath: " << videoError << stop;
      for(videoDrain *const *p = d + 1; *p; p++)
	    vlAddNode(_server, _path, **p);
      if (vlSetupPaths(_server, &_path, 1, VL_SHARE, VL_SHARE) < 0)
 	    cerr << "videoPath::videoPath: vlSetupPaths: " << videoError << stop;
      _transferSize = -1;
      for(videoDrain *const *p = d; *p; p++)
	    (*p) -> pathSetUp(_path);
}

videoSinglePath::videoSinglePath(videoSource *s, videoDrain *d)
:videoPath(d)
{
//       videoServer *s1 = s -> server();
//       videoServer *s2 = d -> server();
//       if (s1 != s2)
// 	    cerr << "videoPath::videoPath: videoServers of source and drain mismatch" << stop;
      videoDrain *drains[] = { d, NIL };
      setup(s, drains);
}

videoSinglePath::videoSinglePath(videoSource *s, videoDrain *const d[])
:videoPath(s)
{
      setup(s, d);
}
